{TSAMP5 - Demonstrates setting, retrieving, and remving Cookies}

{Important note:  The cookie specification includes only 2 digits to represent
the year in which a cookie expires.  They don't specify whether 1-JAN-95 is in
1995 or 2095.  Some browsers, notably Microsoft Internet Explorer, appear to think
that 1-JAN-95 is in 2095, and thus, will not get rid of a cookie with such a date.
To be safe, expire cookies by using a date in the recent past.  In the example below,
we use Now-3 (3 days ago) in order to expire a cookie}

library Tsamp5;

uses
  SysUtils, Classes, Windows,
  ISAPI, TISAPI1;

// GetExtensionVersion is required by the MS IIS.  Don't mess with it.
// CASE MATTERS FOR THIS FUNCTION NAME
function GetExtensionVersion(var ver: THSE_VERSION_INFO): Boolean; stdcall;
begin
  ver.dwExtensionVersion := MAKELONG(HSE_VERSION_MINOR, HSE_VERSION_MAJOR);
  StrPCopy(ver.lpszExtensionDesc, 'Delphi ISAPI DLL');
  result:=True;
end;

// CASE MATTERS FOR THIS FUNCTION NAME
function HttpExtensionProc(var ecb: TEXTENSION_CONTROL_BLOCK): LongInt; stdcall;
var
  MyISAPI : TISAPI;

begin
  MyISAPI := TISAPI.Create; //Create our TECB and assign its published data elements
  with MyISAPI do
  begin
    SetECB(@ecb);    //Set the ECB pointer - Note the @ operator
    try
      if GetCookieVar('BILLIS') <> '' then // We found the cookie!
      begin
        // Here's where we remove the cookie (the date is in the past)
        SETCOOKIEADV('BILLIS', 'NICEGUY', Now-5, '/', '', False);
        SendStdHeader;

        // Here's our web page
        SendLn('<HTML><HEAD><TITLE>Cookie Demonstration</TITLE></HEAD>' );
        SendLn('<BODY>' );
        SendLn('<H1>Cookie Demonstration</H1>' );
        Send('We found the cookie: '+ MyISAPI.GetCookieVar('BILLIS')+ '<BR>');

        SendLn('If we didn''t tell you, you would never know that ' );
        SendLn('we''ve secretly <B>REMOVED</B> the cookie "BILLIS=NICEGUY" ' );
        SendLn('from your client browser.<P> ' );
        SendLn('To verify this run the <A href="/scripts/TSamp1.dll">TSamp1 DLL</A>.<P>' );
        Send('Created with TISAPI version: ' + GetVersion);
        SendLn('</BODY></HTML>' );
      end
      else
      begin
        // Here's where we set the cookie.  It will expire in 30 Days
        SetCookieAdv('BILLIS', 'NICEGUY', Now+30, '/', '', False);
        SendStdHeader;

        // Here's our web page
        SendLn('<HTML><HEAD><TITLE>Cookie Demonstration</TITLE></HEAD>' );
        SendLn('<BODY>' );
        SendLn('<H1>Cookie Demonstration</H1>' );
        SendLn('If we didn''t tell you, you would never know that ' );
        SendLn('we''ve secretly <B>ADDED</B> the cookie "BILLIS=NICEGUY" ' );
        SendLn('to your client browser.<P>  It''s usually stored ' );
        SendLn('in a file called Cookies.txt, somewhere on your hard disk<P>' );
        SendLn('To verify this run the <A href="/scripts/TSamp1.dll">TSamp1 DLL</A>.' );
        SendLn('You may need to reload TSamp1.DLL when you get there.<P>' );
        SendLn('</BODY></HTML>' );
      end;
    finally
      SendLn('</BODY></HTML>' );
      MyISAPI.Free;             // DON'T FORGET TO RELEASE THE RESOURCES
    end;
  end;

  result := HSE_STATUS_SUCCESS;  // That's all folks
end;

// * REQUIRED FOR DYNAMIC BINDING.
exports
  GetExtensionVersion,
  HttpExtensionProc;

begin
end.
