{TSamp6 - Demonstrates Authentication.  REMEMBER: you must set IIS to allow
          Basic (Clear Text) authentication with the IIS Service Manager}

library TSamp6;

uses
  SysUtils, Windows,
  {here are our ISAPI-related files}
  ISAPI, TISAPILt;

{==============================================================================}
{ HttpExtensionProc contains the guts of your ISAPI program.  Here's where you put
  almost all of your code}

Function HttpExtensionProc (var pECB : TEXTENSION_CONTROL_BLOCK) : DWORD; export; stdcall;
Const
  CrLf = ^M^J;  //Just handy to have around
var
  MyISAPI : TISAPI;
begin
  MyISAPI := TISAPI.Create; //Create our TECB and assign its published data elements
  try
    MyISAPI.SetECB(@pECB);    //Set the ECB pointer - Note the @ operator

    if MyISAPI.GetServerVar('REMOTE_USER') = 'Not Available' then // Check to see if the user is already OK
    begin
      MyISAPI.Authenticate;
      MyISAPI.SendStdHeader; // This gets sent if authentication fails
      MyISAPI.Send('<HTML><HEAD><TITLE>Authentication Failed</TITLE></HEAD>' + CrLf);
      MyISAPI.Send('<BODY><CENTER>' + CrLf);
      MyISAPI.Send('<H1>Authentication Failed</H1>' + CrLf);
      MyISAPI.Send('We''re so sorry, but you failed to provide a valid User ID and Password<P>' + CrLf);
      MyISAPI.Send('Please stand back while we blow up your computer.<P>' + CrLf);
      MyISAPI.Send('Thank you, and have a nice day.<P>' + CrLf);
      MyISAPI.Send('</CENTER></BODY></HTML>' + CrLf);
    end
    else
    begin
      MyISAPI.SendStdHeader;    //This gets sent if authentication succeeds
      MyISAPI.Send('<HTML><HEAD><TITLE>Authentication Accepted</TITLE></HEAD>' + CrLf);
      MyISAPI.Send('<BODY>' + CrLf);
      MyISAPI.Send('<H1>Authentication Accepted</H1>' + CrLf);
      MyISAPI.Send('You are clearly a person of high quality<P>' + CrLf);
      MyISAPI.Send('Remote User: '+ MyISAPI.GetServerVar('REMOTE_USER') + '<BR>' + CrLf);
      MyISAPI.Send('Auth Pass: '  + MyISAPI.GetServerVar('AUTH_PASS') + '<BR>' + CrLf);
      MyISAPI.Send('(MS IIS doesn''t let you view the password for security reasons)<P>' + CrLf);
      MyISAPI.Send('Auth Type: '  + MyISAPI.GetServerVar('AUTH_TYPE') + '<P>' + CrLf);
      MyISAPI.Send('</BODY></HTML>' + CrLf);
    end;
  finally
    MyISAPI.Free;
  end;

  result := HSE_STATUS_SUCCESS;  // That's all folks
end;

{==============================================================================}
{GetExtensionVersion is required by the MS IIS.  Don't mess with it.}
Function GetExtensionVersion (var pVer : THSE_VERSION_INFO) : BOOL; export;  stdcall;
begin
  pVer.dwExtensionVersion := MAKELONG(HSE_VERSION_MINOR, HSE_VERSION_MAJOR);
  StrPCopy(pVer.lpszExtensionDesc, 'Delphi ISAPI DLL');
  result := True;
end;

exports
  HttpExtensionProc,
  GetExtensionVersion;

begin
end.

